(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/operators'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-canvas-area-draw', ['exports', 'rxjs/operators', '@angular/core'], factory) :
    (factory((global['ngx-canvas-area-draw'] = {}),global.rxjs.operators,global.ng.core));
}(this, (function (exports,operators,core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var BaseShape = /** @class */ (function () {
        function BaseShape(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) {
            this.renderer = renderer;
            this.parent = parent;
            this.fillColor = fillColor;
            this.strokeColor = strokeColor;
            this.handlerFillColor = handlerFillColor;
            this.handlerStrokeColor = handlerStrokeColor;
            this.points = points || [];
            this._initializeCanvas();
        }
        /**
         * @param {?} colors
         * @return {?}
         */
        BaseShape.prototype.setColors = /**
         * @param {?} colors
         * @return {?}
         */
            function (colors) {
                if (colors.fillColor) {
                    this.fillColor = colors.fillColor;
                }
                if (colors.strokeColor) {
                    this.strokeColor = colors.strokeColor;
                }
                if (colors.handlerFillColor) {
                    this.handlerFillColor = colors.handlerFillColor;
                }
                if (colors.handlerStrokeColor) {
                    this.handlerStrokeColor = colors.handlerStrokeColor;
                }
                this.draw();
            };
        /**
         * @param {?} mousePos
         * @return {?}
         */
        BaseShape.prototype.getPositionInPercent = /**
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                return {
                    x: this.xToPercent(mousePos.x),
                    y: this.yToPercent(mousePos.y)
                };
            };
        /**
         * @param {?} point
         * @return {?}
         */
        BaseShape.prototype.getPointInPx = /**
         * @param {?} point
         * @return {?}
         */
            function (point) {
                return [
                    this.xToPx(point[0]),
                    this.yToPx(point[1])
                ];
            };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseShape.prototype.xToPercent = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value * 100 / this.canvas.width;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseShape.prototype.xToPx = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value * this.canvas.width / 100;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseShape.prototype.yToPercent = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value * 100 / this.canvas.height;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseShape.prototype.yToPx = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value * this.canvas.height / 100;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        BaseShape.prototype.pxToPercent = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                return value * 100 / Math.max(this.canvas.height, this.canvas.width);
            };
        /**
         * @param {?=} inPx
         * @return {?}
         */
        BaseShape.prototype.getBoundaries = /**
         * @param {?=} inPx
         * @return {?}
         */
            function (inPx) {
                if (inPx === void 0) {
                    inPx = true;
                }
                /** @type {?} */
                var minX = 100;
                /** @type {?} */
                var maxX = 0;
                /** @type {?} */
                var minY = 100;
                /** @type {?} */
                var maxY = 0;
                this.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    if (minX > point[0]) {
                        minX = point[0];
                    }
                    if (minY > point[1]) {
                        minY = point[1];
                    }
                    if (maxX < point[0]) {
                        maxX = point[0];
                    }
                    if (maxY < point[1]) {
                        maxY = point[1];
                    }
                }));
                return inPx
                    ? {
                        minX: this.xToPx(minX),
                        maxX: this.xToPx(maxX),
                        minY: this.yToPx(minY),
                        maxY: this.yToPx(maxY)
                    }
                    : {
                        minX: minX,
                        maxX: maxX,
                        minY: minY,
                        maxY: maxY
                    };
            };
        /**
         * @return {?}
         */
        BaseShape.prototype.getWidth = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var boundaries = this.getBoundaries();
                return boundaries.maxX - boundaries.minX;
            };
        /**
         * @return {?}
         */
        BaseShape.prototype.getHeight = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var boundaries = this.getBoundaries();
                return boundaries.maxY - boundaries.minY;
            };
        /**
         * @protected
         * @param {?} point
         * @return {?}
         */
        BaseShape.prototype._drawPoint = /**
         * @protected
         * @param {?} point
         * @return {?}
         */
            function (point) {
                this.context.fillStyle = this.handlerFillColor;
                this.context.strokeStyle = this.handlerStrokeColor;
                this.context.fillRect(point[0] - 3, point[1] - 3, 6, 6);
                this.context.strokeRect(point[0] - 3, point[1] - 3, 6, 6);
            };
        /**
         * @protected
         * @param {?} point
         * @return {?}
         */
        BaseShape.prototype._drawExpander = /**
         * @protected
         * @param {?} point
         * @return {?}
         */
            function (point) {
                this.context.beginPath();
                this.context.fillStyle = this.handlerFillColor;
                this.context.strokeStyle = this.handlerStrokeColor;
                this.context.lineTo(point[0], point[1] - 5);
                this.context.lineTo(point[0] - 5, point[1]);
                this.context.lineTo(point[0], point[1] + 5);
                this.context.lineTo(point[0] + 5, point[1]);
                this.context.closePath();
                this.context.fill();
                this.context.stroke();
            };
        /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
        BaseShape.prototype._getDistances = /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                /** @type {?} */
                var distanceFromMouse;
                /** @type {?} */
                var minDistance = 0;
                /** @type {?} */
                var minDistanceIndex = -1;
                for (var i = 0; i < this.points.length - 1; ++i) {
                    if (this.points[i]) {
                        /** @type {?} */
                        var point = this.getPointInPx(this.points[i]);
                        distanceFromMouse = Math.sqrt(Math.pow(mousePos.x - point[0], 2) + Math.pow(mousePos.y - point[1], 2));
                        if (minDistanceIndex === -1 || minDistance > distanceFromMouse) {
                            minDistance = distanceFromMouse;
                            minDistanceIndex = i;
                        }
                    }
                }
                return {
                    minDistance: minDistance,
                    minDistanceIndex: minDistanceIndex
                };
            };
        /**
         * @private
         * @return {?}
         */
        BaseShape.prototype._initializeCanvas = /**
         * @private
         * @return {?}
         */
            function () {
                this.canvas = this.renderer.createElement('canvas');
                this.context = this.canvas.getContext('2d');
                this.renderer.appendChild(this.parent.nativeElement, this.canvas);
            };
        BaseShape.CLOSE_LIMIT = 6;
        return BaseShape;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var calcPointSegmentDistance = ( /**
     * @param {?} x
     * @param {?} y
     * @param {?} x0
     * @param {?} y0
     * @param {?} x1
     * @param {?} y1
     * @return {?}
     */function (x, y, x0, y0, x1, y1) {
        /** @type {?} */
        var vectorY = y0 - y1;
        /** @type {?} */
        var vectorX = x1 - x0;
        /** @type {?} */
        var vectorModule = x0 * y1 - y0 * x1;
        return Math.abs((vectorY * x) + (vectorX * y) + vectorModule) / Math.sqrt((vectorY * vectorY) + (vectorX * vectorX));
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ BasePath = /** @class */ (function (_super) {
        __extends(BasePath, _super);
        function BasePath(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, allowAddNewPoints, allowModifyPoints) {
            var _this = _super.call(this, renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) || this;
            _this.renderer = renderer;
            _this.parent = parent;
            _this.fillColor = fillColor;
            _this.strokeColor = strokeColor;
            _this.handlerFillColor = handlerFillColor;
            _this.handlerStrokeColor = handlerStrokeColor;
            _this.movingPoint = new core.EventEmitter();
            _this.movingPath = new core.EventEmitter();
            _this.resizingPath = new core.EventEmitter();
            _this.keepInsideContainer = keepInsideContainer;
            _this.forcedAspectRatio = forcedAspectRatio;
            _this.allowAddNewPoints = allowAddNewPoints;
            _this.allowModifyPoints = allowModifyPoints;
            _this._onInit();
            return _this;
        }
        Object.defineProperty(BasePath.prototype, "isActive", {
            get: /**
             * @return {?}
             */ function () {
                return this._isActive;
            },
            set: /**
             * @param {?} isActive
             * @return {?}
             */ function (isActive) {
                var _this = this;
                this._isActive = isActive;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.draw();
                }), 1);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BasePath.prototype.getData = /**
         * @return {?}
         */
            function () {
                return {
                    name: this._getName(),
                    points: this.points,
                    forcedAspectRatio: this.forcedAspectRatio
                };
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype.onMovePoint = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                if (typeof (this._activePointPos) === 'number' && this.points.length > this._activePointPos) {
                    mousePos = this.getPositionInPercent(mousePos);
                    this.points[this._activePointPos][0] = mousePos.x;
                    this.points[this._activePointPos][1] = mousePos.y;
                    this.draw();
                }
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype.onMovePath = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                var _this = this;
                mousePos = this.getPositionInPercent(mousePos);
                if (this.keepInsideContainer && !this._isPositionInsideContainer(mousePos)) {
                    return;
                }
                this.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    point[0] = mousePos.x - _this._movePathStartPoint.x + point[0];
                    point[1] = mousePos.y - _this._movePathStartPoint.y + point[1];
                }));
                this._movePathStartPoint = __assign({}, mousePos);
                this.draw();
            };
        /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype._isPositionInsideContainer = /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                /** @type {?} */
                var boundaries = this.getBoundaries(false);
                /** @type {?} */
                var minX = mousePos.x - this._movePathStartPoint.x + boundaries.minX;
                /** @type {?} */
                var minY = mousePos.y - this._movePathStartPoint.y + boundaries.minY;
                /** @type {?} */
                var maxX = mousePos.x - this._movePathStartPoint.x + boundaries.maxX;
                /** @type {?} */
                var maxY = mousePos.y - this._movePathStartPoint.y + boundaries.maxY;
                return (minX >= 0
                    && minY >= 0
                    && maxX <= 100
                    && maxY <= 100);
            };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BasePath.prototype._deleteNode = /**
         * @protected
         * @param {?} index
         * @return {?}
         */
            function (index) {
                if (this.allowModifyPoints) {
                    this.points.splice(index, 1);
                    this._activePointPos = null;
                    this.draw();
                }
            };
        /**
         * @protected
         * @param {?} insertAt
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype._addPoint = /**
         * @protected
         * @param {?} insertAt
         * @param {?} mousePos
         * @return {?}
         */
            function (insertAt, mousePos) {
                if (this.allowModifyPoints && this.allowAddNewPoints) {
                    mousePos = this.getPositionInPercent(mousePos);
                    this.points.splice(insertAt, 0, [mousePos.x, mousePos.y]);
                    this._activePointPos = insertAt;
                    this.movingPoint.emit();
                    this.draw();
                }
            };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BasePath.prototype._startResizingPath = /**
         * @protected
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this._activePointPos = index;
                this.resizingPath.emit();
            };
        /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype._startMovingPath = /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                this._movePathStartPoint = this.getPositionInPercent(mousePos);
                this.movingPath.emit();
            };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BasePath.prototype._startMovingPointInIndex = /**
         * @protected
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this._activePointPos = index;
                this.movingPoint.emit();
            };
        /**
         * @protected
         * @param {?} distances
         * @return {?}
         */
        BasePath.prototype._shouldStartReizingPath = /**
         * @protected
         * @param {?} distances
         * @return {?}
         */
            function (distances) {
                return (distances.minDistance < BaseShape.CLOSE_LIMIT
                    && distances.minDistanceIndex === 1);
            };
        /**
         * @protected
         * @param {?} distances
         * @return {?}
         */
        BasePath.prototype._shouldStartMovingPoint = /**
         * @protected
         * @param {?} distances
         * @return {?}
         */
            function (distances) {
                return (this.allowModifyPoints
                    && distances.minDistance < BaseShape.CLOSE_LIMIT
                    && distances.minDistanceIndex >= 0);
            };
        /**
         * @protected
         * @param {?} mousePos
         * @param {?} distances
         * @param {?} states
         * @return {?}
         */
        BasePath.prototype._shouldStartMovingPath = /**
         * @protected
         * @param {?} mousePos
         * @param {?} distances
         * @param {?} states
         * @return {?}
         */
            function (mousePos, distances, states) {
                return ((this.context.isPointInPath(mousePos.x, mousePos.y)
                    && (!states.isClose
                        || !(this.allowAddNewPoints && this.allowModifyPoints)))
                    || (distances.minDistance < BaseShape.CLOSE_LIMIT
                        && distances.minDistanceIndex >= 0));
            };
        /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
        BasePath.prototype._getCloseStatus = /**
         * @protected
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                /** @type {?} */
                var lineDis;
                /** @type {?} */
                var isClose = false;
                /** @type {?} */
                var insertAt = this.points.length;
                /** @type {?} */
                var closeLimit = this.pxToPercent(BaseShape.CLOSE_LIMIT);
                mousePos = this.getPositionInPercent(mousePos);
                for (var i = 0; i < this.points.length; ++i) {
                    if (this.points[i]) {
                        if (i >= 1) {
                            lineDis = calcPointSegmentDistance(mousePos.x, mousePos.y, this.points[i][0], this.points[i][1], this.points[i - 1][0], this.points[i - 1][1]);
                            if (lineDis < closeLimit) {
                                insertAt = i;
                            }
                        }
                        else {
                            lineDis = calcPointSegmentDistance(mousePos.x, mousePos.y, this.points[this.points.length - 1][0], this.points[this.points.length - 1][1], this.points[0][0], this.points[0][1]);
                        }
                        if (lineDis < closeLimit) {
                            isClose = true;
                            break;
                        }
                    }
                }
                return {
                    isClose: isClose,
                    insertAt: insertAt
                };
            };
        return BasePath;
    }(BaseShape));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GenericPath = /** @class */ (function (_super) {
        __extends(GenericPath, _super);
        function GenericPath(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer) {
            var _this = _super.call(this, renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, true, true) || this;
            _this.renderer = renderer;
            _this.parent = parent;
            _this.fillColor = fillColor;
            _this.strokeColor = strokeColor;
            _this.handlerFillColor = handlerFillColor;
            _this.handlerStrokeColor = handlerStrokeColor;
            return _this;
        }
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        GenericPath.prototype.onMousedown = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                /** @type {?} */
                var distances = this._getDistances(mousePos);
                if (this._shouldStartMovingPoint(distances)) {
                    this._startMovingPointInIndex(distances.minDistanceIndex);
                }
                else {
                    /** @type {?} */
                    var states = this._getCloseStatus(mousePos);
                    if (this._shouldStartMovingPath(mousePos, distances, states)) {
                        this._startMovingPath(mousePos);
                    }
                    else if (states.isClose && this.allowModifyPoints && this.allowAddNewPoints && event.which === 1) {
                        this._addPoint(states.insertAt, mousePos);
                    }
                }
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @param {?=} allowDelete
         * @return {?}
         */
        GenericPath.prototype.onMouseup = /**
         * @param {?} event
         * @param {?} mousePos
         * @param {?=} allowDelete
         * @return {?}
         */
            function (event, mousePos, allowDelete) {
                if (allowDelete === void 0) {
                    allowDelete = true;
                }
                /** @type {?} */
                var distances = this._getDistances(mousePos);
                if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex >= 0) {
                    if (event.which === 3 && this.points.length > 3) {
                        this._deleteNode(distances.minDistanceIndex);
                        return 'delete node';
                    }
                }
                else if (allowDelete) {
                    /** @type {?} */
                    var states = this._getCloseStatus(mousePos);
                    if (event.which === 3 && this.context.isPointInPath(mousePos.x, mousePos.y) && !states.isClose) {
                        this.context.canvas.width = this.context.canvas.width;
                        return 'delete path';
                    }
                }
                this._activePointPos = null;
                return null;
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        GenericPath.prototype.onResizePath = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
            };
        /**
         * @return {?}
         */
        GenericPath.prototype.draw = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.context.canvas.width = this.context.canvas.width;
                this.context.globalCompositeOperation = 'destination-over';
                this.context.lineWidth = 1;
                this.context.beginPath();
                this.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    point = _this.getPointInPx(point);
                    if (_this.isActive && _this.allowModifyPoints) {
                        _this._drawPoint(point);
                    }
                    _this.context.fillStyle = _this.fillColor;
                    _this.context.strokeStyle = _this.strokeColor;
                    _this.context.lineTo(point[0], point[1]);
                }));
                this.context.closePath();
                this.context.fill();
                this.context.stroke();
            };
        /**
         * @protected
         * @return {?}
         */
        GenericPath.prototype._getName = /**
         * @protected
         * @return {?}
         */
            function () {
                return GenericPath.NAME;
            };
        /**
         * @protected
         * @return {?}
         */
        GenericPath.prototype._onInit = /**
         * @protected
         * @return {?}
         */
            function () {
                this.isActive = false;
            };
        GenericPath.NAME = 'GENERIC_PATH';
        return GenericPath;
    }(BasePath));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Rect = /** @class */ (function (_super) {
        __extends(Rect, _super);
        function Rect(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer) {
            var _this = _super.call(this, renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, false, false) || this;
            _this.renderer = renderer;
            _this.parent = parent;
            _this.fillColor = fillColor;
            _this.strokeColor = strokeColor;
            _this.handlerFillColor = handlerFillColor;
            _this.handlerStrokeColor = handlerStrokeColor;
            return _this;
        }
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        Rect.prototype.onMousedown = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                /** @type {?} */
                var distances = this._getDistances(mousePos);
                if (this._shouldStartReizingPath(distances)) {
                    this._startResizingPath(distances.minDistanceIndex);
                }
                else if (this.context.isPointInPath(mousePos.x, mousePos.y)) {
                    this._startMovingPath(mousePos);
                }
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @param {?=} allowDelete
         * @return {?}
         */
        Rect.prototype.onMouseup = /**
         * @param {?} event
         * @param {?} mousePos
         * @param {?=} allowDelete
         * @return {?}
         */
            function (event, mousePos, allowDelete) {
                if (allowDelete === void 0) {
                    allowDelete = true;
                }
                /** @type {?} */
                var distances = this._getDistances(mousePos);
                if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex >= 0) {
                    if (event.which === 3 && this.points.length > 3) {
                        this._deleteNode(distances.minDistanceIndex);
                        return 'delete node';
                    }
                }
                else if (allowDelete) {
                    /** @type {?} */
                    var states = this._getCloseStatus(mousePos);
                    if (event.which === 3 && this.context.isPointInPath(mousePos.x, mousePos.y) && !states.isClose) {
                        this.context.canvas.width = this.context.canvas.width;
                        return 'delete path';
                    }
                }
                this._activePointPos = null;
                return null;
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        Rect.prototype.onResizePath = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                if (this._activePointPos === 1) {
                    mousePos = this.getPositionInPercent(mousePos);
                    // toDo: fox, 4/10/19 Implement _fitInsideContainer
                    // It should check if the next path size is not overflowing its container
                    // if (this.keepInsideContainer && !this._fitInsideContainer(mousePos)) {
                    //   return;
                    // }
                    // toDo: fox, 4/10/19 FIX this calculations
                    // This should use forcedAspectRatio || 1 as aspect ratio to grow
                    /** @type {?} */
                    var resizeAspectRatioX = mousePos.x / this.points[this._activePointPos][0];
                    /** @type {?} */
                    var resizeAspectRatioY = mousePos.y / this.points[this._activePointPos][1];
                    this.points[0][0] /= resizeAspectRatioX;
                    this.points[0][1] *= resizeAspectRatioY;
                    this.points[1][0] *= resizeAspectRatioX;
                    this.points[1][1] *= resizeAspectRatioY;
                    this.points[2][0] *= resizeAspectRatioX;
                    this.points[2][1] /= resizeAspectRatioY;
                    this.points[3][0] /= resizeAspectRatioX;
                    this.points[3][1] /= resizeAspectRatioY;
                    // **********************************************************************************
                    this.draw();
                }
            };
        /**
         * @return {?}
         */
        Rect.prototype.draw = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.context.canvas.width = this.context.canvas.width;
                this.context.globalCompositeOperation = 'destination-over';
                this.context.lineWidth = 1;
                if (this.isActive) {
                    this._drawExpander(this.getPointInPx(this.points[1]));
                }
                this.context.beginPath();
                this.context.fillStyle = this.fillColor;
                this.context.strokeStyle = this.strokeColor;
                this.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    point = _this.getPointInPx(point);
                    _this.context.lineTo(point[0], point[1]);
                }));
                this.context.closePath();
                this.context.fill();
                this.context.stroke();
            };
        /**
         * @protected
         * @return {?}
         */
        Rect.prototype._getName = /**
         * @protected
         * @return {?}
         */
            function () {
                return Rect.NAME;
            };
        /**
         * @protected
         * @return {?}
         */
        Rect.prototype._onInit = /**
         * @protected
         * @return {?}
         */
            function () {
                if (!this.points || this.points.length === 0) {
                    /** @type {?} */
                    var height = 40 * (this.forcedAspectRatio || 1);
                    /** @type {?} */
                    var left = 30;
                    /** @type {?} */
                    var right = 70;
                    /** @type {?} */
                    var top_1 = 50 - (height / 2);
                    /** @type {?} */
                    var bottom = 50 + (height / 2);
                    this.points = [
                        [left, top_1],
                        [right, top_1],
                        [right, bottom],
                        [left, bottom]
                    ];
                }
                this.isActive = false;
            };
        Rect.NAME = 'RECT';
        return Rect;
    }(BasePath));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Pencil = /** @class */ (function (_super) {
        __extends(Pencil, _super);
        function Pencil(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) {
            var _this = _super.call(this, renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) || this;
            _this.renderer = renderer;
            _this.parent = parent;
            _this.fillColor = fillColor;
            _this.strokeColor = strokeColor;
            _this.handlerFillColor = handlerFillColor;
            _this.handlerStrokeColor = handlerStrokeColor;
            _this.completed = new core.EventEmitter();
            _this._onInit();
            return _this;
        }
        /**
         * @return {?}
         */
        Pencil.prototype.reset = /**
         * @return {?}
         */
            function () {
                this.points = [];
                this._activePointPos = 0;
                this._isCompleted = false;
                this.renderer.setStyle(this.canvas, 'display', 'none');
                this.context.canvas.width = this.context.canvas.width;
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        Pencil.prototype.onMouseup = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                if (!this._isCompleted) {
                    if (event.which === 1) {
                        this._addPoint(mousePos);
                    }
                    else {
                        this._removeLastPoint();
                    }
                    this.draw();
                    return null;
                }
            };
        /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
        Pencil.prototype.onMovePoint = /**
         * @param {?} event
         * @param {?} mousePos
         * @return {?}
         */
            function (event, mousePos) {
                if (!this._isCompleted && typeof (this._activePointPos) === 'number') {
                    mousePos = this.getPositionInPercent(mousePos);
                    this.points[this._activePointPos] = [mousePos.x, mousePos.y];
                    this.draw();
                }
            };
        /**
         * @return {?}
         */
        Pencil.prototype.draw = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.context.canvas.width = this.context.canvas.width;
                this.context.globalCompositeOperation = 'destination-over';
                this.context.lineWidth = 1;
                this.context.beginPath();
                this.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    point = _this.getPointInPx(point);
                    _this._drawPoint(point);
                    _this.context.strokeStyle = _this.strokeColor;
                    _this.context.lineTo(point[0], point[1]);
                }));
                if (this._isCompleted) {
                    this.context.closePath();
                    this.completed.emit();
                }
                this.context.stroke();
            };
        /**
         * @protected
         * @return {?}
         */
        Pencil.prototype._onInit = /**
         * @protected
         * @return {?}
         */
            function () {
                this._activePointPos = this.points.length;
                this._isCompleted = false;
                this.renderer.setStyle(this.canvas, 'display', 'none');
            };
        /**
         * @protected
         * @return {?}
         */
        Pencil.prototype._getName = /**
         * @protected
         * @return {?}
         */
            function () {
                return Pencil.NAME;
            };
        /**
         * @private
         * @param {?} mousePos
         * @return {?}
         */
        Pencil.prototype._addPoint = /**
         * @private
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                /** @type {?} */
                var distances = this._getDistances(mousePos);
                if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex === 0 && this.points.length > 3) {
                    this._closeShape();
                }
                else if (distances.minDistance >= BaseShape.CLOSE_LIMIT || this.points.length === 1) {
                    this._activePointPos += 1;
                }
            };
        /**
         * @private
         * @return {?}
         */
        Pencil.prototype._closeShape = /**
         * @private
         * @return {?}
         */
            function () {
                this.points.splice(this.points.length - 1, 1);
                this._activePointPos -= 1;
                this._isCompleted = true;
            };
        /**
         * @private
         * @return {?}
         */
        Pencil.prototype._removeLastPoint = /**
         * @private
         * @return {?}
         */
            function () {
                this.points.splice(this.points.length - 2, 1);
                this._activePointPos -= 1;
                if (this._activePointPos === -1) {
                    this.completed.emit();
                }
            };
        Pencil.NAME = 'PENCIL';
        return Pencil;
    }(BaseShape));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var register = {};
    register[GenericPath.NAME] = GenericPath;
    register[Rect.NAME] = Rect;
    /**
     * @param {?} name
     * @param {?} args
     * @return {?}
     */
    function getShape(name, args) {
        var _a;
        if (register.hasOwnProperty(name)) {
            return new ((_a = register[name]).bind.apply(_a, __spread([void 0], args)))();
        }
        throw new ReferenceError("Unknown shape \"" + name + "\", available shapes are: " + Object.keys(register));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // toDo: fox, 4/10/19 Rename to cadWorkspace
    var NgxCanvasAreaDrawDirective = /** @class */ (function () {
        function NgxCanvasAreaDrawDirective(element, renderer, ngZone) {
            this.element = element;
            this.renderer = renderer;
            this.ngZone = ngZone;
            this.defaultPaths = [];
            this.allowDelete = true;
            this.activePathChange = new core.EventEmitter();
            this.pathAdded = new core.EventEmitter();
            this.pathDeleted = new core.EventEmitter();
            this.paths = [];
            this._strokeColor = NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR;
            this._fillColor = NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR;
            this._handlerStrokeColor = NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR;
            this._handlerFillColor = NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR;
            this._pathsSubscription = [];
            this._resetIndicators();
            this.renderer.setStyle(this.element.nativeElement, 'position', 'relative');
        }
        Object.defineProperty(NgxCanvasAreaDrawDirective.prototype, "imageUrl", {
            get: /**
             * @return {?}
             */ function () {
                return this._imageUrl;
            },
            // toDo: fox, 4/10/19 Receive also an image file
            set: 
            // toDo: fox, 4/10/19 Receive also an image file
            /**
             * @param {?} url
             * @return {?}
             */
            function (url) {
                var _this = this;
                if (!this.isLoading) {
                    this._resetIndicators();
                    this._removeAllMouseListeners();
                    this._removeAllPaths();
                    this._imageUrl = url;
                    if (url) {
                        this.ngZone.runOutsideAngular(( /**
                         * @return {?}
                         */function () { return _this._paint(); }));
                    }
                    else {
                        this._removeBaseImage();
                        this.isLoading = false;
                    }
                }
                else if (url) {
                    this._imageUrl = url;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCanvasAreaDrawDirective.prototype, "strokeColor", {
            get: /**
             * @return {?}
             */ function () {
                return this._strokeColor;
            },
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color && this._strokeColor) {
                    this._applyStrokeColor(color);
                }
                this._strokeColor = color || NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCanvasAreaDrawDirective.prototype, "fillColor", {
            get: /**
             * @return {?}
             */ function () {
                return this._fillColor;
            },
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color && this._fillColor) {
                    this._applyFillColor(color);
                }
                this._fillColor = color || NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCanvasAreaDrawDirective.prototype, "handlerStrokeColor", {
            get: /**
             * @return {?}
             */ function () {
                return this._handlerStrokeColor;
            },
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color && this._handlerStrokeColor) {
                    this.applyHandlerStrokeColor(color);
                }
                this._handlerStrokeColor = color || NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCanvasAreaDrawDirective.prototype, "handlerFillColor", {
            get: /**
             * @return {?}
             */ function () {
                return this._handlerFillColor;
            },
            set: /**
             * @param {?} color
             * @return {?}
             */ function (color) {
                if (color && this._handlerFillColor) {
                    this._applyHandlerFillColor(color);
                }
                this._handlerFillColor = color || NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.ngZone.runOutsideAngular(( /**
                 * @return {?}
                 */function () { return _this._paint(); }));
            };
        // toDo: fox, 4/10/19 Isolate this method from the directive, it should receive:
        // the points
        // base image
        // dimensions: width & height
        // toDo: fox, 4/10/19 Isolate this method from the directive, it should receive:
        // the points
        // base image
        // dimensions: width & height
        /**
         * @param {?} path
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.getPathImage =
            // toDo: fox, 4/10/19 Isolate this method from the directive, it should receive:
            // the points
            // base image
            // dimensions: width & height
            /**
             * @param {?} path
             * @return {?}
             */
            function (path) {
                /** @type {?} */
                var canvas = this.renderer.createElement('canvas');
                /** @type {?} */
                var context = canvas.getContext('2d');
                /** @type {?} */
                var pathBoundaries = path.getBoundaries();
                canvas.width = pathBoundaries.maxX - pathBoundaries.minX;
                canvas.height = pathBoundaries.maxY - pathBoundaries.minY;
                path.points
                    .filter(( /**
             * @param {?} point
             * @return {?}
             */function (point) { return point && point.length > 0; }))
                    .forEach(( /**
             * @param {?} point
             * @return {?}
             */function (point) {
                    point = path.getPointInPx(point);
                    context.lineTo(point[0] - pathBoundaries.minX, point[1] - pathBoundaries.minY);
                }));
                context.closePath();
                context.clip();
                context.drawImage(this._baseImage, -pathBoundaries.minX, -pathBoundaries.minY, this.width, this.height);
                // toDo: fox, 4/10/19 convert to JPEG to save size
                return canvas.toDataURL('image/png', 0.96);
            };
        // toDo: fox, 4/10/19 Implement a method to get the image file
        // toDo: fox, 4/10/19 Implement a method to get the image file
        /**
         * @param {?=} position
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.getImageInPosition =
            // toDo: fox, 4/10/19 Implement a method to get the image file
            /**
             * @param {?=} position
             * @return {?}
             */
            function (position) {
                if (position === void 0) {
                    position = null;
                }
                if (typeof (position) !== 'number') {
                    position = this._activePathPosition;
                }
                if (typeof (position) === 'number' && this.paths.length > position) {
                    /** @type {?} */
                    var path = this.paths[position];
                    return this.getPathImage(path);
                }
                return null;
            };
        /**
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.startDrawing = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.isLoading && !this.isDrawing) {
                    this.isDrawing = true;
                    this._setActivePathPosition(null);
                    this._setUpPencil();
                    this._pencilSubscription = this._pencil.completed
                        .pipe(operators.take(1))
                        .subscribe(( /**
                 * @return {?}
                 */function () { return _this._finishDrawing(); }));
                    this._MousemoveListener = this.renderer.listen(this._baseCanvas, 'mousemove', this._onMovePoint.bind(this));
                }
            };
        /**
         * @param {?} pathData
         * @param {?=} notifyChange
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.addPath = /**
         * @param {?} pathData
         * @param {?=} notifyChange
         * @return {?}
         */
            function (pathData, notifyChange) {
                var _this = this;
                if (notifyChange === void 0) {
                    notifyChange = true;
                }
                /** @type {?} */
                var newPath = getShape(pathData.name, [
                    this.renderer,
                    this.element,
                    this.strokeColor,
                    this.fillColor,
                    this.handlerFillColor,
                    this.handlerStrokeColor,
                    pathData.points,
                    pathData.forcedAspectRatio,
                    pathData.keepInsideContainer
                ]);
                this._setStyle(newPath.canvas, (this.paths.length + 2).toString());
                this.renderer.setStyle(this._baseCanvas, 'z-index', this.paths.length + 3);
                /** @type {?} */
                var movePointSubscription = newPath.movingPoint
                    .subscribe(( /**
             * @return {?}
             */function () {
                    _this._MousemoveListener = _this.renderer.listen(_this._baseCanvas, 'mousemove', _this._onMovePoint.bind(_this));
                }));
                /** @type {?} */
                var movePathSubscription = newPath.movingPath
                    .subscribe(( /**
             * @return {?}
             */function () {
                    _this._MousemoveListener = _this.renderer.listen(_this._baseCanvas, 'mousemove', _this._onMovePath.bind(_this));
                }));
                /** @type {?} */
                var resizePathSubscription = newPath.resizingPath
                    .subscribe(( /**
             * @return {?}
             */function () {
                    _this._MousemoveListener = _this.renderer.listen(_this._baseCanvas, 'mousemove', _this._onResizePath.bind(_this));
                }));
                this._pathsSubscription.push([movePointSubscription, movePathSubscription, resizePathSubscription]);
                this.paths.push(newPath);
                if (notifyChange) {
                    this.paths
                        .filter(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) { return path.isActive; }))
                        .forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                        path.isActive = false;
                    }));
                    this.pathAdded.emit();
                    this._setActivePathPosition(this.paths.length - 1);
                }
            };
        /**
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._removeAllListeners();
                this._deleteAllPathsSubscriptions();
                if (this._pencilSubscription) {
                    this._pencilSubscription.unsubscribe();
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._updateGeometry = /**
         * @private
         * @return {?}
         */
            function () {
                this.height = this._baseImage.height;
                this.width = this._baseImage.width;
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.scaleContent = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this._updateGeometry();
                if (this._baseCanvas) {
                    this._setGeometry(this._baseCanvas);
                }
                if (this._pencil) {
                    this._setGeometry(this._pencil.canvas);
                    this._pencil.draw();
                }
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    _this._setGeometry(path.canvas);
                    path.draw();
                }));
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._setUpPencil = /**
         * @private
         * @return {?}
         */
            function () {
                this.renderer.setStyle(this._pencil.canvas, 'display', 'block');
                this.renderer.setStyle(this._pencil.canvas, 'z-index', this.paths.length + 2);
                this.renderer.setStyle(this._baseCanvas, 'z-index', this.paths.length + 3);
                this.renderer.setStyle(this._baseCanvas, 'cursor', 'copy');
            };
        /**
         * @private
         * @param {?} position
         * @param {?=} deactivateCurrent
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._setActivePathPosition = /**
         * @private
         * @param {?} position
         * @param {?=} deactivateCurrent
         * @return {?}
         */
            function (position, deactivateCurrent) {
                if (deactivateCurrent === void 0) {
                    deactivateCurrent = true;
                }
                if (deactivateCurrent && typeof (this._activePathPosition) === 'number') {
                    this.paths[this._activePathPosition].isActive = false;
                }
                if (typeof (position) === 'number') {
                    this.paths[position].isActive = true;
                }
                else if (this._activePathPosition === position) {
                    return;
                }
                this._activePathPosition = position;
                this.activePathChange.emit(position);
            };
        /**
         * @private
         * @param {?} color
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype.applyHandlerStrokeColor = /**
         * @private
         * @param {?} color
         * @return {?}
         */
            function (color) {
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    path.setColors({
                        handlerStrokeColor: color
                    });
                }));
                if (this._pencil) {
                    this._pencil.setColors({
                        handlerStrokeColor: color
                    });
                }
            };
        /**
         * @private
         * @param {?} color
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._applyHandlerFillColor = /**
         * @private
         * @param {?} color
         * @return {?}
         */
            function (color) {
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    path.setColors({
                        handlerFillColor: color
                    });
                }));
                if (this._pencil) {
                    this._pencil.setColors({
                        handlerFillColor: color
                    });
                }
            };
        /**
         * @private
         * @param {?} color
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._applyFillColor = /**
         * @private
         * @param {?} color
         * @return {?}
         */
            function (color) {
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    path.setColors({
                        fillColor: color
                    });
                }));
            };
        /**
         * @private
         * @param {?} color
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._applyStrokeColor = /**
         * @private
         * @param {?} color
         * @return {?}
         */
            function (color) {
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    path.setColors({
                        strokeColor: color
                    });
                }));
                if (this._pencil) {
                    this._pencil.setColors({
                        strokeColor: color
                    });
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removeBaseImage = /**
         * @private
         * @return {?}
         */
            function () {
                if (this._baseImage) {
                    this._ImageLoadListener();
                    this._ImageErrorListener();
                    this.renderer.removeChild(this.element.nativeElement, this._baseImage);
                    this._baseImage = null;
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removeAllPaths = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this._deleteAllPathsSubscriptions();
                this.paths.forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (path) {
                    _this.renderer.removeChild(_this.element.nativeElement, path.canvas);
                }));
                this.paths = [];
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removeBaseCanvas = /**
         * @private
         * @return {?}
         */
            function () {
                if (this._baseCanvas) {
                    this._removeAllMouseListeners();
                    this.renderer.removeChild(this.element.nativeElement, this._baseCanvas);
                    this._baseCanvas = null;
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._createNewBaseCanvas = /**
         * @private
         * @return {?}
         */
            function () {
                this._removeBaseCanvas();
                this._baseCanvas = this.renderer.createElement('canvas');
                this.renderer.appendChild(this.element.nativeElement, this._baseCanvas);
                this._MouseLeaveListener = this.renderer.listen(this._baseCanvas, 'mouseleave', this._onMouseleave.bind(this));
                this._MousedownListener = this.renderer.listen(this._baseCanvas, 'mousedown', this._onMousedown.bind(this));
                this._MouseupListener = this.renderer.listen(this._baseCanvas, 'mouseup', this._onMouseup.bind(this));
                this._ContextmenuListener = this.renderer.listen(this._baseCanvas, 'contextmenu', this._onContextmenu.bind(this));
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removePencil = /**
         * @private
         * @return {?}
         */
            function () {
                if (this._pencil) {
                    this.renderer.removeChild(this.element.nativeElement, this._pencil.canvas);
                    this._pencil = null;
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._resetIndicators = /**
         * @private
         * @return {?}
         */
            function () {
                this.isLoading = true;
                this.isDrawing = false;
                this.height = null;
                this.width = null;
                this._activePathPosition = null;
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._createBaseImage = /**
         * @private
         * @return {?}
         */
            function () {
                this._baseImage = this.renderer.createElement('img');
                this.renderer.setAttribute(this._baseImage, 'crossOrigin', 'Anonymous');
                this._setStyle(this._baseImage, '1');
                this._listenImageLoad();
                this._listenImageImageError();
                this.renderer.appendChild(this.element.nativeElement, this._baseImage);
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._listenImageImageError = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this._ImageErrorListener = this.renderer.listen(this._baseImage, 'error', ( /**
                 * @return {?}
                 */function () {
                    _this.isLoading = false;
                }));
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._listenImageLoad = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this._ImageLoadListener = this.renderer.listen(this._baseImage, 'load', ( /**
                 * @return {?}
                 */function () {
                    _this._updateGeometry();
                    _this._createNewPencil();
                    _this._setStyle(_this._baseCanvas, '3');
                    _this._addDefaultPaths();
                    _this.isLoading = false;
                }));
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._createNewPencil = /**
         * @private
         * @return {?}
         */
            function () {
                this._removePencil();
                this._pencil = new Pencil(this.renderer, this.element, null, this.strokeColor, this.handlerFillColor, this.handlerStrokeColor);
                this._setStyle(this._pencil.canvas, '0');
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._addDefaultPaths = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.defaultPaths.length > 0) {
                    this.defaultPaths.forEach(( /**
                     * @param {?} pathData
                     * @param {?} index
                     * @return {?}
                     */function (pathData, index) {
                        _this.addPath(pathData, false);
                        if (_this.defaultActivePathIndex === index) {
                            _this._setActivePathPosition(index);
                        }
                    }));
                    this.defaultPaths = [];
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._paint = /**
         * @private
         * @return {?}
         */
            function () {
                this._createNewBaseCanvas();
                if (!this._baseImage) {
                    this._createBaseImage();
                }
                if (this.imageUrl) {
                    this.renderer.setAttribute(this._baseImage, 'src', this.imageUrl);
                }
                else {
                    this.isLoading = false;
                }
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._finishDrawing = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.isDrawing) {
                    this._MousemoveListener();
                    this.isDrawing = false;
                    /** @type {?} */
                    var points = this._pencil.points.filter(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x; }));
                    this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
                    this._pencil.reset();
                    if (points) {
                        this.addPath({
                            name: GenericPath.NAME,
                            points: points
                        });
                    }
                }
            };
        /**
         * @private
         * @param {?} mousePos
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._checkPathClicked = /**
         * @private
         * @param {?} mousePos
         * @return {?}
         */
            function (mousePos) {
                var _this = this;
                this.paths
                    .filter(( /**
             * @param {?} path
             * @return {?}
             */function (path) { return path.context.isPointInPath(mousePos.x, mousePos.y); }))
                    .slice(-1)
                    .map(( /**
             * @param {?} path
             * @return {?}
             */function (path) { return _this.paths.indexOf(path); }))
                    .forEach(( /**
             * @param {?} index
             * @return {?}
             */function (index) { return _this._setActivePathPosition(index); }));
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onMouseleave = /**
         * @private
         * @return {?}
         */
            function () {
                this._setActivePathPosition(null);
                if (!this.isDrawing) {
                    this._MousemoveListener();
                    this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
                }
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onMousedown = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.preventDefault();
                if (event.which === 1) {
                    /** @type {?} */
                    var mousePos = this._getMousePos(event);
                    if (!this.isDrawing) {
                        if (this.paths.length > 0) {
                            this._checkPathClicked(mousePos);
                            if (typeof (this._activePathPosition) === 'number' && this.paths.length > this._activePathPosition) {
                                this.paths[this._activePathPosition].onMousedown(event, mousePos);
                            }
                        }
                    }
                    else {
                        this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
                    }
                }
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onMouseup = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.which === 1 || event.which === 3) {
                    /** @type {?} */
                    var mousePos = this._getMousePos(event);
                    if (this.isDrawing) {
                        this.renderer.setStyle(this._baseCanvas, 'cursor', 'copy');
                        this._pencil.onMouseup(event, mousePos);
                    }
                    else {
                        this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
                        this._MousemoveListener();
                        if (typeof (this._activePathPosition) === 'number' && this.paths.length > this._activePathPosition) {
                            /** @type {?} */
                            var action = this.paths[this._activePathPosition].onMouseup(event, mousePos, this.allowDelete);
                            if (action === 'delete path') {
                                this._deletePath();
                            }
                            else if (action) {
                                this.activePathChange.emit(this._activePathPosition);
                            }
                        }
                    }
                }
                return false;
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._deletePath = /**
         * @private
         * @return {?}
         */
            function () {
                this.renderer.removeChild(this.element.nativeElement, this.paths[this._activePathPosition].canvas);
                this.paths.splice(this._activePathPosition, 1);
                this._deletePathSubscription(this._activePathPosition);
                this.pathDeleted.emit(this._activePathPosition);
                if (this.paths.length > 0) {
                    this._setActivePathPosition(this.paths.length - 1, false);
                }
                else {
                    this._setActivePathPosition(null, false);
                }
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onContextmenu = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.preventDefault();
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onMovePath = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (typeof (this._activePathPosition) === 'number') {
                    /** @type {?} */
                    var mousePos = this._getMousePos(event);
                    if (this.notifyWhileMoving) {
                        this.activePathChange.emit(this._activePathPosition);
                    }
                    this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
                    this.paths[this._activePathPosition].onMovePath(event, mousePos);
                }
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onMovePoint = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var mousePos = this._getMousePos(event);
                if (this.isDrawing) {
                    this._pencil.onMovePoint(event, mousePos);
                }
                else if (typeof (this._activePathPosition) === 'number') {
                    if (this.notifyWhileMoving) {
                        this.activePathChange.emit(this._activePathPosition);
                    }
                    this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
                    this.paths[this._activePathPosition].onMovePoint(event, mousePos);
                }
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._onResizePath = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (typeof (this._activePathPosition) === 'number') {
                    /** @type {?} */
                    var mousePos = this._getMousePos(event);
                    if (this.notifyWhileMoving) {
                        this.activePathChange.emit(this._activePathPosition);
                    }
                    this.renderer.setStyle(this._baseCanvas, 'cursor', 'ne-resize');
                    this.paths[this._activePathPosition].onResizePath(event, mousePos);
                }
                return false;
            };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._getMousePos = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var rect = this._baseCanvas.getBoundingClientRect();
                return {
                    x: event.clientX - rect.left,
                    y: event.clientY - rect.top
                };
            };
        /**
         * @private
         * @param {?} element
         * @param {?} zIndex
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._setStyle = /**
         * @private
         * @param {?} element
         * @param {?} zIndex
         * @return {?}
         */
            function (element, zIndex) {
                this.renderer.setStyle(element, 'position', 'absolute');
                this.renderer.setStyle(element, 'top', '0');
                this.renderer.setStyle(element, 'left', '0');
                this.renderer.setStyle(element, 'z-index', zIndex);
                if (this.height && this.width) {
                    this._setGeometry(element);
                }
                else {
                    this.renderer.setStyle(element, 'height', 'auto');
                    this.renderer.setStyle(element, 'width', '100%');
                }
            };
        /**
         * @private
         * @param {?} element
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._setGeometry = /**
         * @private
         * @param {?} element
         * @return {?}
         */
            function (element) {
                this.renderer.setAttribute(element, 'height', "" + this.height);
                this.renderer.setAttribute(element, 'width', "" + this.width);
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._deleteAllPathsSubscriptions = /**
         * @private
         * @return {?}
         */
            function () {
                var e_1, _a, e_2, _b;
                try {
                    for (var _c = __values(this._pathsSubscription), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var subscriptions = _d.value;
                        try {
                            for (var subscriptions_1 = __values(subscriptions), subscriptions_1_1 = subscriptions_1.next(); !subscriptions_1_1.done; subscriptions_1_1 = subscriptions_1.next()) {
                                var subscription = subscriptions_1_1.value;
                                subscription.unsubscribe();
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (subscriptions_1_1 && !subscriptions_1_1.done && (_b = subscriptions_1.return))
                                    _b.call(subscriptions_1);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                this._pathsSubscription = [];
            };
        /**
         * @private
         * @param {?} pos
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._deletePathSubscription = /**
         * @private
         * @param {?} pos
         * @return {?}
         */
            function (pos) {
                var e_3, _a;
                try {
                    for (var _b = __values(this._pathsSubscription[pos]), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var subscription = _c.value;
                        subscription.unsubscribe();
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                this._pathsSubscription.splice(pos, 1);
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removeAllListeners = /**
         * @private
         * @return {?}
         */
            function () {
                this._removeAllMouseListeners();
                this._ImageLoadListener();
                this._ImageErrorListener();
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._removeAllMouseListeners = /**
         * @private
         * @return {?}
         */
            function () {
                this._MousedownListener();
                this._MouseupListener();
                this._MouseLeaveListener();
                this._MousemoveListener();
                this._ContextmenuListener();
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._MousedownListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._MouseupListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._MouseLeaveListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._MousemoveListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._ContextmenuListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._ImageLoadListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        /**
         * @private
         * @return {?}
         */
        NgxCanvasAreaDrawDirective.prototype._ImageErrorListener = /**
         * @private
         * @return {?}
         */
            function () {
            };
        NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR = 'rgba(255, 255, 255, 0.7)';
        NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR = 'rgba(255, 255, 255, 0.2)';
        NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR = 'rgba(255, 255, 255, 1)';
        NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR = 'rgba(255, 255, 255, 1)';
        NgxCanvasAreaDrawDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[canvasAreaDraw]',
                        exportAs: 'canvasAreaDraw'
                    },] }
        ];
        /** @nocollapse */
        NgxCanvasAreaDrawDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.Renderer2 },
                { type: core.NgZone }
            ];
        };
        NgxCanvasAreaDrawDirective.propDecorators = {
            defaultPaths: [{ type: core.Input }],
            defaultActivePathIndex: [{ type: core.Input }],
            notifyWhileMoving: [{ type: core.Input }],
            allowDelete: [{ type: core.Input }],
            activePathChange: [{ type: core.Output }],
            pathAdded: [{ type: core.Output }],
            pathDeleted: [{ type: core.Output }],
            imageUrl: [{ type: core.Input, args: ['canvasAreaDraw',] }],
            strokeColor: [{ type: core.Input, args: ['strokeColor',] }],
            fillColor: [{ type: core.Input, args: ['fillColor',] }],
            handlerStrokeColor: [{ type: core.Input, args: ['handlerStrokeColor',] }],
            handlerFillColor: [{ type: core.Input, args: ['handlerFillColor',] }],
            scaleContent: [{ type: core.HostListener, args: ['window:resize',] }]
        };
        return NgxCanvasAreaDrawDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxCanvasAreaDrawModule = /** @class */ (function () {
        function NgxCanvasAreaDrawModule() {
        }
        NgxCanvasAreaDrawModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            NgxCanvasAreaDrawDirective
                        ],
                        exports: [
                            NgxCanvasAreaDrawDirective
                        ]
                    },] }
        ];
        return NgxCanvasAreaDrawModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.getShape = getShape;
    exports.BaseShape = BaseShape;
    exports.BasePath = BasePath;
    exports.GenericPath = GenericPath;
    exports.Rect = Rect;
    exports.Pencil = Pencil;
    exports.NgxCanvasAreaDrawDirective = NgxCanvasAreaDrawDirective;
    exports.NgxCanvasAreaDrawModule = NgxCanvasAreaDrawModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-canvas-area-draw.umd.js.map