import { take } from 'rxjs/operators';
import { EventEmitter, Directive, ElementRef, HostListener, Input, NgZone, Output, Renderer2, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class BaseShape {
    /**
     * @protected
     * @param {?} renderer
     * @param {?} parent
     * @param {?} fillColor
     * @param {?} strokeColor
     * @param {?} handlerFillColor
     * @param {?} handlerStrokeColor
     * @param {?} points
     */
    constructor(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) {
        this.renderer = renderer;
        this.parent = parent;
        this.fillColor = fillColor;
        this.strokeColor = strokeColor;
        this.handlerFillColor = handlerFillColor;
        this.handlerStrokeColor = handlerStrokeColor;
        this.points = points || [];
        this._initializeCanvas();
    }
    /**
     * @param {?} colors
     * @return {?}
     */
    setColors(colors) {
        if (colors.fillColor) {
            this.fillColor = colors.fillColor;
        }
        if (colors.strokeColor) {
            this.strokeColor = colors.strokeColor;
        }
        if (colors.handlerFillColor) {
            this.handlerFillColor = colors.handlerFillColor;
        }
        if (colors.handlerStrokeColor) {
            this.handlerStrokeColor = colors.handlerStrokeColor;
        }
        this.draw();
    }
    /**
     * @param {?} mousePos
     * @return {?}
     */
    getPositionInPercent(mousePos) {
        return {
            x: this.xToPercent(mousePos.x),
            y: this.yToPercent(mousePos.y)
        };
    }
    /**
     * @param {?} point
     * @return {?}
     */
    getPointInPx(point) {
        return [
            this.xToPx(point[0]),
            this.yToPx(point[1])
        ];
    }
    /**
     * @param {?} value
     * @return {?}
     */
    xToPercent(value) {
        return value * 100 / this.canvas.width;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    xToPx(value) {
        return value * this.canvas.width / 100;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    yToPercent(value) {
        return value * 100 / this.canvas.height;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    yToPx(value) {
        return value * this.canvas.height / 100;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    pxToPercent(value) {
        return value * 100 / Math.max(this.canvas.height, this.canvas.width);
    }
    /**
     * @param {?=} inPx
     * @return {?}
     */
    getBoundaries(inPx = true) {
        /** @type {?} */
        let minX = 100;
        /** @type {?} */
        let maxX = 0;
        /** @type {?} */
        let minY = 100;
        /** @type {?} */
        let maxY = 0;
        this.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            if (minX > point[0]) {
                minX = point[0];
            }
            if (minY > point[1]) {
                minY = point[1];
            }
            if (maxX < point[0]) {
                maxX = point[0];
            }
            if (maxY < point[1]) {
                maxY = point[1];
            }
        }));
        return inPx
            ? {
                minX: this.xToPx(minX),
                maxX: this.xToPx(maxX),
                minY: this.yToPx(minY),
                maxY: this.yToPx(maxY)
            }
            : {
                minX,
                maxX,
                minY,
                maxY
            };
    }
    /**
     * @return {?}
     */
    getWidth() {
        /** @type {?} */
        const boundaries = this.getBoundaries();
        return boundaries.maxX - boundaries.minX;
    }
    /**
     * @return {?}
     */
    getHeight() {
        /** @type {?} */
        const boundaries = this.getBoundaries();
        return boundaries.maxY - boundaries.minY;
    }
    /**
     * @protected
     * @param {?} point
     * @return {?}
     */
    _drawPoint(point) {
        this.context.fillStyle = this.handlerFillColor;
        this.context.strokeStyle = this.handlerStrokeColor;
        this.context.fillRect(point[0] - 3, point[1] - 3, 6, 6);
        this.context.strokeRect(point[0] - 3, point[1] - 3, 6, 6);
    }
    /**
     * @protected
     * @param {?} point
     * @return {?}
     */
    _drawExpander(point) {
        this.context.beginPath();
        this.context.fillStyle = this.handlerFillColor;
        this.context.strokeStyle = this.handlerStrokeColor;
        this.context.lineTo(point[0], point[1] - 5);
        this.context.lineTo(point[0] - 5, point[1]);
        this.context.lineTo(point[0], point[1] + 5);
        this.context.lineTo(point[0] + 5, point[1]);
        this.context.closePath();
        this.context.fill();
        this.context.stroke();
    }
    /**
     * @protected
     * @param {?} mousePos
     * @return {?}
     */
    _getDistances(mousePos) {
        /** @type {?} */
        let distanceFromMouse;
        /** @type {?} */
        let minDistance = 0;
        /** @type {?} */
        let minDistanceIndex = -1;
        for (let i = 0; i < this.points.length - 1; ++i) {
            if (this.points[i]) {
                /** @type {?} */
                const point = this.getPointInPx(this.points[i]);
                distanceFromMouse = Math.sqrt(Math.pow(mousePos.x - point[0], 2) + Math.pow(mousePos.y - point[1], 2));
                if (minDistanceIndex === -1 || minDistance > distanceFromMouse) {
                    minDistance = distanceFromMouse;
                    minDistanceIndex = i;
                }
            }
        }
        return {
            minDistance,
            minDistanceIndex
        };
    }
    /**
     * @private
     * @return {?}
     */
    _initializeCanvas() {
        this.canvas = this.renderer.createElement('canvas');
        this.context = this.canvas.getContext('2d');
        this.renderer.appendChild(this.parent.nativeElement, this.canvas);
    }
}
BaseShape.CLOSE_LIMIT = 6;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const calcPointSegmentDistance = (/**
 * @param {?} x
 * @param {?} y
 * @param {?} x0
 * @param {?} y0
 * @param {?} x1
 * @param {?} y1
 * @return {?}
 */
(x, y, x0, y0, x1, y1) => {
    /** @type {?} */
    const vectorY = y0 - y1;
    /** @type {?} */
    const vectorX = x1 - x0;
    /** @type {?} */
    const vectorModule = x0 * y1 - y0 * x1;
    return Math.abs((vectorY * x) + (vectorX * y) + vectorModule) / Math.sqrt((vectorY * vectorY) + (vectorX * vectorX));
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class BasePath extends BaseShape {
    /**
     * @protected
     * @param {?} renderer
     * @param {?} parent
     * @param {?} fillColor
     * @param {?} strokeColor
     * @param {?} handlerFillColor
     * @param {?} handlerStrokeColor
     * @param {?} points
     * @param {?} forcedAspectRatio
     * @param {?} keepInsideContainer
     * @param {?} allowAddNewPoints
     * @param {?} allowModifyPoints
     */
    constructor(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, allowAddNewPoints, allowModifyPoints) {
        super(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points);
        this.renderer = renderer;
        this.parent = parent;
        this.fillColor = fillColor;
        this.strokeColor = strokeColor;
        this.handlerFillColor = handlerFillColor;
        this.handlerStrokeColor = handlerStrokeColor;
        this.movingPoint = new EventEmitter();
        this.movingPath = new EventEmitter();
        this.resizingPath = new EventEmitter();
        this.keepInsideContainer = keepInsideContainer;
        this.forcedAspectRatio = forcedAspectRatio;
        this.allowAddNewPoints = allowAddNewPoints;
        this.allowModifyPoints = allowModifyPoints;
        this._onInit();
    }
    /**
     * @return {?}
     */
    get isActive() {
        return this._isActive;
    }
    /**
     * @param {?} isActive
     * @return {?}
     */
    set isActive(isActive) {
        this._isActive = isActive;
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.draw();
        }), 1);
    }
    /**
     * @return {?}
     */
    getData() {
        return {
            name: this._getName(),
            points: this.points,
            forcedAspectRatio: this.forcedAspectRatio
        };
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMovePoint(event, mousePos) {
        if (typeof (this._activePointPos) === 'number' && this.points.length > this._activePointPos) {
            mousePos = this.getPositionInPercent(mousePos);
            this.points[this._activePointPos][0] = mousePos.x;
            this.points[this._activePointPos][1] = mousePos.y;
            this.draw();
        }
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMovePath(event, mousePos) {
        mousePos = this.getPositionInPercent(mousePos);
        if (this.keepInsideContainer && !this._isPositionInsideContainer(mousePos)) {
            return;
        }
        this.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            point[0] = mousePos.x - this._movePathStartPoint.x + point[0];
            point[1] = mousePos.y - this._movePathStartPoint.y + point[1];
        }));
        this._movePathStartPoint = Object.assign({}, mousePos);
        this.draw();
    }
    /**
     * @protected
     * @param {?} mousePos
     * @return {?}
     */
    _isPositionInsideContainer(mousePos) {
        /** @type {?} */
        const boundaries = this.getBoundaries(false);
        /** @type {?} */
        const minX = mousePos.x - this._movePathStartPoint.x + boundaries.minX;
        /** @type {?} */
        const minY = mousePos.y - this._movePathStartPoint.y + boundaries.minY;
        /** @type {?} */
        const maxX = mousePos.x - this._movePathStartPoint.x + boundaries.maxX;
        /** @type {?} */
        const maxY = mousePos.y - this._movePathStartPoint.y + boundaries.maxY;
        return (minX >= 0
            && minY >= 0
            && maxX <= 100
            && maxY <= 100);
    }
    /**
     * @protected
     * @param {?} index
     * @return {?}
     */
    _deleteNode(index) {
        if (this.allowModifyPoints) {
            this.points.splice(index, 1);
            this._activePointPos = null;
            this.draw();
        }
    }
    /**
     * @protected
     * @param {?} insertAt
     * @param {?} mousePos
     * @return {?}
     */
    _addPoint(insertAt, mousePos) {
        if (this.allowModifyPoints && this.allowAddNewPoints) {
            mousePos = this.getPositionInPercent(mousePos);
            this.points.splice(insertAt, 0, [mousePos.x, mousePos.y]);
            this._activePointPos = insertAt;
            this.movingPoint.emit();
            this.draw();
        }
    }
    /**
     * @protected
     * @param {?} index
     * @return {?}
     */
    _startResizingPath(index) {
        this._activePointPos = index;
        this.resizingPath.emit();
    }
    /**
     * @protected
     * @param {?} mousePos
     * @return {?}
     */
    _startMovingPath(mousePos) {
        this._movePathStartPoint = this.getPositionInPercent(mousePos);
        this.movingPath.emit();
    }
    /**
     * @protected
     * @param {?} index
     * @return {?}
     */
    _startMovingPointInIndex(index) {
        this._activePointPos = index;
        this.movingPoint.emit();
    }
    /**
     * @protected
     * @param {?} distances
     * @return {?}
     */
    _shouldStartReizingPath(distances) {
        return (distances.minDistance < BaseShape.CLOSE_LIMIT
            && distances.minDistanceIndex === 1);
    }
    /**
     * @protected
     * @param {?} distances
     * @return {?}
     */
    _shouldStartMovingPoint(distances) {
        return (this.allowModifyPoints
            && distances.minDistance < BaseShape.CLOSE_LIMIT
            && distances.minDistanceIndex >= 0);
    }
    /**
     * @protected
     * @param {?} mousePos
     * @param {?} distances
     * @param {?} states
     * @return {?}
     */
    _shouldStartMovingPath(mousePos, distances, states) {
        return ((this.context.isPointInPath(mousePos.x, mousePos.y)
            && (!states.isClose
                || !(this.allowAddNewPoints && this.allowModifyPoints)))
            || (distances.minDistance < BaseShape.CLOSE_LIMIT
                && distances.minDistanceIndex >= 0));
    }
    /**
     * @protected
     * @param {?} mousePos
     * @return {?}
     */
    _getCloseStatus(mousePos) {
        /** @type {?} */
        let lineDis;
        /** @type {?} */
        let isClose = false;
        /** @type {?} */
        let insertAt = this.points.length;
        /** @type {?} */
        const closeLimit = this.pxToPercent(BaseShape.CLOSE_LIMIT);
        mousePos = this.getPositionInPercent(mousePos);
        for (let i = 0; i < this.points.length; ++i) {
            if (this.points[i]) {
                if (i >= 1) {
                    lineDis = calcPointSegmentDistance(mousePos.x, mousePos.y, this.points[i][0], this.points[i][1], this.points[i - 1][0], this.points[i - 1][1]);
                    if (lineDis < closeLimit) {
                        insertAt = i;
                    }
                }
                else {
                    lineDis = calcPointSegmentDistance(mousePos.x, mousePos.y, this.points[this.points.length - 1][0], this.points[this.points.length - 1][1], this.points[0][0], this.points[0][1]);
                }
                if (lineDis < closeLimit) {
                    isClose = true;
                    break;
                }
            }
        }
        return {
            isClose,
            insertAt
        };
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GenericPath extends BasePath {
    /**
     * @param {?} renderer
     * @param {?} parent
     * @param {?} fillColor
     * @param {?} strokeColor
     * @param {?} handlerFillColor
     * @param {?} handlerStrokeColor
     * @param {?} points
     * @param {?} forcedAspectRatio
     * @param {?} keepInsideContainer
     */
    constructor(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer) {
        super(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, true, true);
        this.renderer = renderer;
        this.parent = parent;
        this.fillColor = fillColor;
        this.strokeColor = strokeColor;
        this.handlerFillColor = handlerFillColor;
        this.handlerStrokeColor = handlerStrokeColor;
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMousedown(event, mousePos) {
        /** @type {?} */
        const distances = this._getDistances(mousePos);
        if (this._shouldStartMovingPoint(distances)) {
            this._startMovingPointInIndex(distances.minDistanceIndex);
        }
        else {
            /** @type {?} */
            const states = this._getCloseStatus(mousePos);
            if (this._shouldStartMovingPath(mousePos, distances, states)) {
                this._startMovingPath(mousePos);
            }
            else if (states.isClose && this.allowModifyPoints && this.allowAddNewPoints && event.which === 1) {
                this._addPoint(states.insertAt, mousePos);
            }
        }
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @param {?=} allowDelete
     * @return {?}
     */
    onMouseup(event, mousePos, allowDelete = true) {
        /** @type {?} */
        const distances = this._getDistances(mousePos);
        if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex >= 0) {
            if (event.which === 3 && this.points.length > 3) {
                this._deleteNode(distances.minDistanceIndex);
                return 'delete node';
            }
        }
        else if (allowDelete) {
            /** @type {?} */
            const states = this._getCloseStatus(mousePos);
            if (event.which === 3 && this.context.isPointInPath(mousePos.x, mousePos.y) && !states.isClose) {
                this.context.canvas.width = this.context.canvas.width;
                return 'delete path';
            }
        }
        this._activePointPos = null;
        return null;
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onResizePath(event, mousePos) {
    }
    /**
     * @return {?}
     */
    draw() {
        this.context.canvas.width = this.context.canvas.width;
        this.context.globalCompositeOperation = 'destination-over';
        this.context.lineWidth = 1;
        this.context.beginPath();
        this.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            point = this.getPointInPx(point);
            if (this.isActive && this.allowModifyPoints) {
                this._drawPoint(point);
            }
            this.context.fillStyle = this.fillColor;
            this.context.strokeStyle = this.strokeColor;
            this.context.lineTo(point[0], point[1]);
        }));
        this.context.closePath();
        this.context.fill();
        this.context.stroke();
    }
    /**
     * @protected
     * @return {?}
     */
    _getName() {
        return GenericPath.NAME;
    }
    /**
     * @protected
     * @return {?}
     */
    _onInit() {
        this.isActive = false;
    }
}
GenericPath.NAME = 'GENERIC_PATH';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Rect extends BasePath {
    /**
     * @param {?} renderer
     * @param {?} parent
     * @param {?} fillColor
     * @param {?} strokeColor
     * @param {?} handlerFillColor
     * @param {?} handlerStrokeColor
     * @param {?} points
     * @param {?} forcedAspectRatio
     * @param {?} keepInsideContainer
     */
    constructor(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer) {
        super(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points, forcedAspectRatio, keepInsideContainer, false, false);
        this.renderer = renderer;
        this.parent = parent;
        this.fillColor = fillColor;
        this.strokeColor = strokeColor;
        this.handlerFillColor = handlerFillColor;
        this.handlerStrokeColor = handlerStrokeColor;
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMousedown(event, mousePos) {
        /** @type {?} */
        const distances = this._getDistances(mousePos);
        if (this._shouldStartReizingPath(distances)) {
            this._startResizingPath(distances.minDistanceIndex);
        }
        else if (this.context.isPointInPath(mousePos.x, mousePos.y)) {
            this._startMovingPath(mousePos);
        }
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @param {?=} allowDelete
     * @return {?}
     */
    onMouseup(event, mousePos, allowDelete = true) {
        /** @type {?} */
        const distances = this._getDistances(mousePos);
        if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex >= 0) {
            if (event.which === 3 && this.points.length > 3) {
                this._deleteNode(distances.minDistanceIndex);
                return 'delete node';
            }
        }
        else if (allowDelete) {
            /** @type {?} */
            const states = this._getCloseStatus(mousePos);
            if (event.which === 3 && this.context.isPointInPath(mousePos.x, mousePos.y) && !states.isClose) {
                this.context.canvas.width = this.context.canvas.width;
                return 'delete path';
            }
        }
        this._activePointPos = null;
        return null;
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onResizePath(event, mousePos) {
        if (this._activePointPos === 1) {
            mousePos = this.getPositionInPercent(mousePos);
            // toDo: fox, 4/10/19 Implement _fitInsideContainer
            // It should check if the next path size is not overflowing its container
            // if (this.keepInsideContainer && !this._fitInsideContainer(mousePos)) {
            //   return;
            // }
            // toDo: fox, 4/10/19 FIX this calculations
            // This should use forcedAspectRatio || 1 as aspect ratio to grow
            /** @type {?} */
            const resizeAspectRatioX = mousePos.x / this.points[this._activePointPos][0];
            /** @type {?} */
            const resizeAspectRatioY = mousePos.y / this.points[this._activePointPos][1];
            this.points[0][0] /= resizeAspectRatioX;
            this.points[0][1] *= resizeAspectRatioY;
            this.points[1][0] *= resizeAspectRatioX;
            this.points[1][1] *= resizeAspectRatioY;
            this.points[2][0] *= resizeAspectRatioX;
            this.points[2][1] /= resizeAspectRatioY;
            this.points[3][0] /= resizeAspectRatioX;
            this.points[3][1] /= resizeAspectRatioY;
            // **********************************************************************************
            this.draw();
        }
    }
    /**
     * @return {?}
     */
    draw() {
        this.context.canvas.width = this.context.canvas.width;
        this.context.globalCompositeOperation = 'destination-over';
        this.context.lineWidth = 1;
        if (this.isActive) {
            this._drawExpander(this.getPointInPx(this.points[1]));
        }
        this.context.beginPath();
        this.context.fillStyle = this.fillColor;
        this.context.strokeStyle = this.strokeColor;
        this.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            point = this.getPointInPx(point);
            this.context.lineTo(point[0], point[1]);
        }));
        this.context.closePath();
        this.context.fill();
        this.context.stroke();
    }
    /**
     * @protected
     * @return {?}
     */
    _getName() {
        return Rect.NAME;
    }
    /**
     * @protected
     * @return {?}
     */
    _onInit() {
        if (!this.points || this.points.length === 0) {
            /** @type {?} */
            const height = 40 * (this.forcedAspectRatio || 1);
            /** @type {?} */
            const left = 30;
            /** @type {?} */
            const right = 70;
            /** @type {?} */
            const top = 50 - (height / 2);
            /** @type {?} */
            const bottom = 50 + (height / 2);
            this.points = [
                [left, top],
                [right, top],
                [right, bottom],
                [left, bottom]
            ];
        }
        this.isActive = false;
    }
}
Rect.NAME = 'RECT';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Pencil extends BaseShape {
    /**
     * @param {?} renderer
     * @param {?} parent
     * @param {?} fillColor
     * @param {?} strokeColor
     * @param {?} handlerFillColor
     * @param {?} handlerStrokeColor
     * @param {?=} points
     */
    constructor(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points) {
        super(renderer, parent, fillColor, strokeColor, handlerFillColor, handlerStrokeColor, points);
        this.renderer = renderer;
        this.parent = parent;
        this.fillColor = fillColor;
        this.strokeColor = strokeColor;
        this.handlerFillColor = handlerFillColor;
        this.handlerStrokeColor = handlerStrokeColor;
        this.completed = new EventEmitter();
        this._onInit();
    }
    /**
     * @return {?}
     */
    reset() {
        this.points = [];
        this._activePointPos = 0;
        this._isCompleted = false;
        this.renderer.setStyle(this.canvas, 'display', 'none');
        this.context.canvas.width = this.context.canvas.width;
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMouseup(event, mousePos) {
        if (!this._isCompleted) {
            if (event.which === 1) {
                this._addPoint(mousePos);
            }
            else {
                this._removeLastPoint();
            }
            this.draw();
            return null;
        }
    }
    /**
     * @param {?} event
     * @param {?} mousePos
     * @return {?}
     */
    onMovePoint(event, mousePos) {
        if (!this._isCompleted && typeof (this._activePointPos) === 'number') {
            mousePos = this.getPositionInPercent(mousePos);
            this.points[this._activePointPos] = [mousePos.x, mousePos.y];
            this.draw();
        }
    }
    /**
     * @return {?}
     */
    draw() {
        this.context.canvas.width = this.context.canvas.width;
        this.context.globalCompositeOperation = 'destination-over';
        this.context.lineWidth = 1;
        this.context.beginPath();
        this.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            point = this.getPointInPx(point);
            this._drawPoint(point);
            this.context.strokeStyle = this.strokeColor;
            this.context.lineTo(point[0], point[1]);
        }));
        if (this._isCompleted) {
            this.context.closePath();
            this.completed.emit();
        }
        this.context.stroke();
    }
    /**
     * @protected
     * @return {?}
     */
    _onInit() {
        this._activePointPos = this.points.length;
        this._isCompleted = false;
        this.renderer.setStyle(this.canvas, 'display', 'none');
    }
    /**
     * @protected
     * @return {?}
     */
    _getName() {
        return Pencil.NAME;
    }
    /**
     * @private
     * @param {?} mousePos
     * @return {?}
     */
    _addPoint(mousePos) {
        /** @type {?} */
        const distances = this._getDistances(mousePos);
        if (distances.minDistance < BaseShape.CLOSE_LIMIT && distances.minDistanceIndex === 0 && this.points.length > 3) {
            this._closeShape();
        }
        else if (distances.minDistance >= BaseShape.CLOSE_LIMIT || this.points.length === 1) {
            this._activePointPos += 1;
        }
    }
    /**
     * @private
     * @return {?}
     */
    _closeShape() {
        this.points.splice(this.points.length - 1, 1);
        this._activePointPos -= 1;
        this._isCompleted = true;
    }
    /**
     * @private
     * @return {?}
     */
    _removeLastPoint() {
        this.points.splice(this.points.length - 2, 1);
        this._activePointPos -= 1;
        if (this._activePointPos === -1) {
            this.completed.emit();
        }
    }
}
Pencil.NAME = 'PENCIL';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const register = {};
register[GenericPath.NAME] = GenericPath;
register[Rect.NAME] = Rect;
/**
 * @param {?} name
 * @param {?} args
 * @return {?}
 */
function getShape(name, args) {
    if (register.hasOwnProperty(name)) {
        return new register[name](...args);
    }
    throw new ReferenceError(`Unknown shape "${name}", available shapes are: ${Object.keys(register)}`);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// toDo: fox, 4/10/19 Rename to cadWorkspace
class NgxCanvasAreaDrawDirective {
    /**
     * @param {?} element
     * @param {?} renderer
     * @param {?} ngZone
     */
    constructor(element, renderer, ngZone) {
        this.element = element;
        this.renderer = renderer;
        this.ngZone = ngZone;
        this.defaultPaths = [];
        this.allowDelete = true;
        this.activePathChange = new EventEmitter();
        this.pathAdded = new EventEmitter();
        this.pathDeleted = new EventEmitter();
        this.paths = [];
        this._strokeColor = NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR;
        this._fillColor = NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR;
        this._handlerStrokeColor = NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR;
        this._handlerFillColor = NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR;
        this._pathsSubscription = [];
        this._resetIndicators();
        this.renderer.setStyle(this.element.nativeElement, 'position', 'relative');
    }
    /**
     * @return {?}
     */
    get imageUrl() {
        return this._imageUrl;
    }
    // toDo: fox, 4/10/19 Receive also an image file
    /**
     * @param {?} url
     * @return {?}
     */
    set imageUrl(url) {
        if (!this.isLoading) {
            this._resetIndicators();
            this._removeAllMouseListeners();
            this._removeAllPaths();
            this._imageUrl = url;
            if (url) {
                this.ngZone.runOutsideAngular((/**
                 * @return {?}
                 */
                () => this._paint()));
            }
            else {
                this._removeBaseImage();
                this.isLoading = false;
            }
        }
        else if (url) {
            this._imageUrl = url;
        }
    }
    /**
     * @return {?}
     */
    get strokeColor() {
        return this._strokeColor;
    }
    /**
     * @param {?} color
     * @return {?}
     */
    set strokeColor(color) {
        if (color && this._strokeColor) {
            this._applyStrokeColor(color);
        }
        this._strokeColor = color || NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR;
    }
    /**
     * @return {?}
     */
    get fillColor() {
        return this._fillColor;
    }
    /**
     * @param {?} color
     * @return {?}
     */
    set fillColor(color) {
        if (color && this._fillColor) {
            this._applyFillColor(color);
        }
        this._fillColor = color || NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR;
    }
    /**
     * @return {?}
     */
    get handlerStrokeColor() {
        return this._handlerStrokeColor;
    }
    /**
     * @param {?} color
     * @return {?}
     */
    set handlerStrokeColor(color) {
        if (color && this._handlerStrokeColor) {
            this.applyHandlerStrokeColor(color);
        }
        this._handlerStrokeColor = color || NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR;
    }
    /**
     * @return {?}
     */
    get handlerFillColor() {
        return this._handlerFillColor;
    }
    /**
     * @param {?} color
     * @return {?}
     */
    set handlerFillColor(color) {
        if (color && this._handlerFillColor) {
            this._applyHandlerFillColor(color);
        }
        this._handlerFillColor = color || NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.ngZone.runOutsideAngular((/**
         * @return {?}
         */
        () => this._paint()));
    }
    // toDo: fox, 4/10/19 Isolate this method from the directive, it should receive:
    // the points
    // base image
    // dimensions: width & height
    /**
     * @param {?} path
     * @return {?}
     */
    getPathImage(path) {
        /** @type {?} */
        const canvas = this.renderer.createElement('canvas');
        /** @type {?} */
        const context = canvas.getContext('2d');
        /** @type {?} */
        const pathBoundaries = path.getBoundaries();
        canvas.width = pathBoundaries.maxX - pathBoundaries.minX;
        canvas.height = pathBoundaries.maxY - pathBoundaries.minY;
        path.points
            .filter((/**
         * @param {?} point
         * @return {?}
         */
        (point) => point && point.length > 0))
            .forEach((/**
         * @param {?} point
         * @return {?}
         */
        (point) => {
            point = path.getPointInPx(point);
            context.lineTo(point[0] - pathBoundaries.minX, point[1] - pathBoundaries.minY);
        }));
        context.closePath();
        context.clip();
        context.drawImage(this._baseImage, -pathBoundaries.minX, -pathBoundaries.minY, this.width, this.height);
        // toDo: fox, 4/10/19 convert to JPEG to save size
        return canvas.toDataURL('image/png', 0.96);
    }
    // toDo: fox, 4/10/19 Implement a method to get the image file
    /**
     * @param {?=} position
     * @return {?}
     */
    getImageInPosition(position = null) {
        if (typeof (position) !== 'number') {
            position = this._activePathPosition;
        }
        if (typeof (position) === 'number' && this.paths.length > position) {
            /** @type {?} */
            const path = this.paths[position];
            return this.getPathImage(path);
        }
        return null;
    }
    /**
     * @return {?}
     */
    startDrawing() {
        if (!this.isLoading && !this.isDrawing) {
            this.isDrawing = true;
            this._setActivePathPosition(null);
            this._setUpPencil();
            this._pencilSubscription = this._pencil.completed
                .pipe(take(1))
                .subscribe((/**
             * @return {?}
             */
            () => this._finishDrawing()));
            this._MousemoveListener = this.renderer.listen(this._baseCanvas, 'mousemove', this._onMovePoint.bind(this));
        }
    }
    /**
     * @param {?} pathData
     * @param {?=} notifyChange
     * @return {?}
     */
    addPath(pathData, notifyChange = true) {
        /** @type {?} */
        const newPath = getShape(pathData.name, [
            this.renderer,
            this.element,
            this.strokeColor,
            this.fillColor,
            this.handlerFillColor,
            this.handlerStrokeColor,
            pathData.points,
            pathData.forcedAspectRatio,
            pathData.keepInsideContainer
        ]);
        this._setStyle(newPath.canvas, (this.paths.length + 2).toString());
        this.renderer.setStyle(this._baseCanvas, 'z-index', this.paths.length + 3);
        /** @type {?} */
        const movePointSubscription = newPath.movingPoint
            .subscribe((/**
         * @return {?}
         */
        () => {
            this._MousemoveListener = this.renderer.listen(this._baseCanvas, 'mousemove', this._onMovePoint.bind(this));
        }));
        /** @type {?} */
        const movePathSubscription = newPath.movingPath
            .subscribe((/**
         * @return {?}
         */
        () => {
            this._MousemoveListener = this.renderer.listen(this._baseCanvas, 'mousemove', this._onMovePath.bind(this));
        }));
        /** @type {?} */
        const resizePathSubscription = newPath.resizingPath
            .subscribe((/**
         * @return {?}
         */
        () => {
            this._MousemoveListener = this.renderer.listen(this._baseCanvas, 'mousemove', this._onResizePath.bind(this));
        }));
        this._pathsSubscription.push([movePointSubscription, movePathSubscription, resizePathSubscription]);
        this.paths.push(newPath);
        if (notifyChange) {
            this.paths
                .filter((/**
             * @param {?} path
             * @return {?}
             */
            (path) => path.isActive))
                .forEach((/**
             * @param {?} path
             * @return {?}
             */
            (path) => {
                path.isActive = false;
            }));
            this.pathAdded.emit();
            this._setActivePathPosition(this.paths.length - 1);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._removeAllListeners();
        this._deleteAllPathsSubscriptions();
        if (this._pencilSubscription) {
            this._pencilSubscription.unsubscribe();
        }
    }
    /**
     * @private
     * @return {?}
     */
    _updateGeometry() {
        this.height = this._baseImage.height;
        this.width = this._baseImage.width;
    }
    /**
     * @private
     * @return {?}
     */
    scaleContent() {
        this._updateGeometry();
        if (this._baseCanvas) {
            this._setGeometry(this._baseCanvas);
        }
        if (this._pencil) {
            this._setGeometry(this._pencil.canvas);
            this._pencil.draw();
        }
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            this._setGeometry(path.canvas);
            path.draw();
        }));
    }
    /**
     * @private
     * @return {?}
     */
    _setUpPencil() {
        this.renderer.setStyle(this._pencil.canvas, 'display', 'block');
        this.renderer.setStyle(this._pencil.canvas, 'z-index', this.paths.length + 2);
        this.renderer.setStyle(this._baseCanvas, 'z-index', this.paths.length + 3);
        this.renderer.setStyle(this._baseCanvas, 'cursor', 'copy');
    }
    /**
     * @private
     * @param {?} position
     * @param {?=} deactivateCurrent
     * @return {?}
     */
    _setActivePathPosition(position, deactivateCurrent = true) {
        if (deactivateCurrent && typeof (this._activePathPosition) === 'number') {
            this.paths[this._activePathPosition].isActive = false;
        }
        if (typeof (position) === 'number') {
            this.paths[position].isActive = true;
        }
        else if (this._activePathPosition === position) {
            return;
        }
        this._activePathPosition = position;
        this.activePathChange.emit(position);
    }
    /**
     * @private
     * @param {?} color
     * @return {?}
     */
    applyHandlerStrokeColor(color) {
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            path.setColors({
                handlerStrokeColor: color
            });
        }));
        if (this._pencil) {
            this._pencil.setColors({
                handlerStrokeColor: color
            });
        }
    }
    /**
     * @private
     * @param {?} color
     * @return {?}
     */
    _applyHandlerFillColor(color) {
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            path.setColors({
                handlerFillColor: color
            });
        }));
        if (this._pencil) {
            this._pencil.setColors({
                handlerFillColor: color
            });
        }
    }
    /**
     * @private
     * @param {?} color
     * @return {?}
     */
    _applyFillColor(color) {
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            path.setColors({
                fillColor: color
            });
        }));
    }
    /**
     * @private
     * @param {?} color
     * @return {?}
     */
    _applyStrokeColor(color) {
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            path.setColors({
                strokeColor: color
            });
        }));
        if (this._pencil) {
            this._pencil.setColors({
                strokeColor: color
            });
        }
    }
    /**
     * @private
     * @return {?}
     */
    _removeBaseImage() {
        if (this._baseImage) {
            this._ImageLoadListener();
            this._ImageErrorListener();
            this.renderer.removeChild(this.element.nativeElement, this._baseImage);
            this._baseImage = null;
        }
    }
    /**
     * @private
     * @return {?}
     */
    _removeAllPaths() {
        this._deleteAllPathsSubscriptions();
        this.paths.forEach((/**
         * @param {?} path
         * @return {?}
         */
        (path) => {
            this.renderer.removeChild(this.element.nativeElement, path.canvas);
        }));
        this.paths = [];
    }
    /**
     * @private
     * @return {?}
     */
    _removeBaseCanvas() {
        if (this._baseCanvas) {
            this._removeAllMouseListeners();
            this.renderer.removeChild(this.element.nativeElement, this._baseCanvas);
            this._baseCanvas = null;
        }
    }
    /**
     * @private
     * @return {?}
     */
    _createNewBaseCanvas() {
        this._removeBaseCanvas();
        this._baseCanvas = this.renderer.createElement('canvas');
        this.renderer.appendChild(this.element.nativeElement, this._baseCanvas);
        this._MouseLeaveListener = this.renderer.listen(this._baseCanvas, 'mouseleave', this._onMouseleave.bind(this));
        this._MousedownListener = this.renderer.listen(this._baseCanvas, 'mousedown', this._onMousedown.bind(this));
        this._MouseupListener = this.renderer.listen(this._baseCanvas, 'mouseup', this._onMouseup.bind(this));
        this._ContextmenuListener = this.renderer.listen(this._baseCanvas, 'contextmenu', this._onContextmenu.bind(this));
    }
    /**
     * @private
     * @return {?}
     */
    _removePencil() {
        if (this._pencil) {
            this.renderer.removeChild(this.element.nativeElement, this._pencil.canvas);
            this._pencil = null;
        }
    }
    /**
     * @private
     * @return {?}
     */
    _resetIndicators() {
        this.isLoading = true;
        this.isDrawing = false;
        this.height = null;
        this.width = null;
        this._activePathPosition = null;
    }
    /**
     * @private
     * @return {?}
     */
    _createBaseImage() {
        this._baseImage = this.renderer.createElement('img');
        this.renderer.setAttribute(this._baseImage, 'crossOrigin', 'Anonymous');
        this._setStyle(this._baseImage, '1');
        this._listenImageLoad();
        this._listenImageImageError();
        this.renderer.appendChild(this.element.nativeElement, this._baseImage);
    }
    /**
     * @private
     * @return {?}
     */
    _listenImageImageError() {
        this._ImageErrorListener = this.renderer.listen(this._baseImage, 'error', (/**
         * @return {?}
         */
        () => {
            this.isLoading = false;
        }));
    }
    /**
     * @private
     * @return {?}
     */
    _listenImageLoad() {
        this._ImageLoadListener = this.renderer.listen(this._baseImage, 'load', (/**
         * @return {?}
         */
        () => {
            this._updateGeometry();
            this._createNewPencil();
            this._setStyle(this._baseCanvas, '3');
            this._addDefaultPaths();
            this.isLoading = false;
        }));
    }
    /**
     * @private
     * @return {?}
     */
    _createNewPencil() {
        this._removePencil();
        this._pencil = new Pencil(this.renderer, this.element, null, this.strokeColor, this.handlerFillColor, this.handlerStrokeColor);
        this._setStyle(this._pencil.canvas, '0');
    }
    /**
     * @private
     * @return {?}
     */
    _addDefaultPaths() {
        if (this.defaultPaths.length > 0) {
            this.defaultPaths.forEach((/**
             * @param {?} pathData
             * @param {?} index
             * @return {?}
             */
            (pathData, index) => {
                this.addPath(pathData, false);
                if (this.defaultActivePathIndex === index) {
                    this._setActivePathPosition(index);
                }
            }));
            this.defaultPaths = [];
        }
    }
    /**
     * @private
     * @return {?}
     */
    _paint() {
        this._createNewBaseCanvas();
        if (!this._baseImage) {
            this._createBaseImage();
        }
        if (this.imageUrl) {
            this.renderer.setAttribute(this._baseImage, 'src', this.imageUrl);
        }
        else {
            this.isLoading = false;
        }
    }
    /**
     * @private
     * @return {?}
     */
    _finishDrawing() {
        if (this.isDrawing) {
            this._MousemoveListener();
            this.isDrawing = false;
            /** @type {?} */
            const points = this._pencil.points.filter((/**
             * @param {?} x
             * @return {?}
             */
            x => x));
            this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
            this._pencil.reset();
            if (points) {
                this.addPath({
                    name: GenericPath.NAME,
                    points
                });
            }
        }
    }
    /**
     * @private
     * @param {?} mousePos
     * @return {?}
     */
    _checkPathClicked(mousePos) {
        this.paths
            .filter((/**
         * @param {?} path
         * @return {?}
         */
        (path) => path.context.isPointInPath(mousePos.x, mousePos.y)))
            .slice(-1)
            .map((/**
         * @param {?} path
         * @return {?}
         */
        (path) => this.paths.indexOf(path)))
            .forEach((/**
         * @param {?} index
         * @return {?}
         */
        (index) => this._setActivePathPosition(index)));
    }
    /**
     * @private
     * @return {?}
     */
    _onMouseleave() {
        this._setActivePathPosition(null);
        if (!this.isDrawing) {
            this._MousemoveListener();
            this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
        }
        return false;
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onMousedown(event) {
        event.preventDefault();
        if (event.which === 1) {
            /** @type {?} */
            const mousePos = this._getMousePos(event);
            if (!this.isDrawing) {
                if (this.paths.length > 0) {
                    this._checkPathClicked(mousePos);
                    if (typeof (this._activePathPosition) === 'number' && this.paths.length > this._activePathPosition) {
                        this.paths[this._activePathPosition].onMousedown(event, mousePos);
                    }
                }
            }
            else {
                this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
            }
        }
        return false;
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onMouseup(event) {
        if (event.which === 1 || event.which === 3) {
            /** @type {?} */
            const mousePos = this._getMousePos(event);
            if (this.isDrawing) {
                this.renderer.setStyle(this._baseCanvas, 'cursor', 'copy');
                this._pencil.onMouseup(event, mousePos);
            }
            else {
                this.renderer.setStyle(this._baseCanvas, 'cursor', 'default');
                this._MousemoveListener();
                if (typeof (this._activePathPosition) === 'number' && this.paths.length > this._activePathPosition) {
                    /** @type {?} */
                    const action = this.paths[this._activePathPosition].onMouseup(event, mousePos, this.allowDelete);
                    if (action === 'delete path') {
                        this._deletePath();
                    }
                    else if (action) {
                        this.activePathChange.emit(this._activePathPosition);
                    }
                }
            }
        }
        return false;
    }
    /**
     * @private
     * @return {?}
     */
    _deletePath() {
        this.renderer.removeChild(this.element.nativeElement, this.paths[this._activePathPosition].canvas);
        this.paths.splice(this._activePathPosition, 1);
        this._deletePathSubscription(this._activePathPosition);
        this.pathDeleted.emit(this._activePathPosition);
        if (this.paths.length > 0) {
            this._setActivePathPosition(this.paths.length - 1, false);
        }
        else {
            this._setActivePathPosition(null, false);
        }
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onContextmenu(event) {
        event.preventDefault();
        return false;
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onMovePath(event) {
        if (typeof (this._activePathPosition) === 'number') {
            /** @type {?} */
            const mousePos = this._getMousePos(event);
            if (this.notifyWhileMoving) {
                this.activePathChange.emit(this._activePathPosition);
            }
            this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
            this.paths[this._activePathPosition].onMovePath(event, mousePos);
        }
        return false;
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onMovePoint(event) {
        /** @type {?} */
        const mousePos = this._getMousePos(event);
        if (this.isDrawing) {
            this._pencil.onMovePoint(event, mousePos);
        }
        else if (typeof (this._activePathPosition) === 'number') {
            if (this.notifyWhileMoving) {
                this.activePathChange.emit(this._activePathPosition);
            }
            this.renderer.setStyle(this._baseCanvas, 'cursor', 'move');
            this.paths[this._activePathPosition].onMovePoint(event, mousePos);
        }
        return false;
    }
    ;
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _onResizePath(event) {
        if (typeof (this._activePathPosition) === 'number') {
            /** @type {?} */
            const mousePos = this._getMousePos(event);
            if (this.notifyWhileMoving) {
                this.activePathChange.emit(this._activePathPosition);
            }
            this.renderer.setStyle(this._baseCanvas, 'cursor', 'ne-resize');
            this.paths[this._activePathPosition].onResizePath(event, mousePos);
        }
        return false;
    }
    /**
     * @private
     * @param {?} event
     * @return {?}
     */
    _getMousePos(event) {
        /** @type {?} */
        const rect = this._baseCanvas.getBoundingClientRect();
        return {
            x: event.clientX - rect.left,
            y: event.clientY - rect.top
        };
    }
    /**
     * @private
     * @param {?} element
     * @param {?} zIndex
     * @return {?}
     */
    _setStyle(element, zIndex) {
        this.renderer.setStyle(element, 'position', 'absolute');
        this.renderer.setStyle(element, 'top', '0');
        this.renderer.setStyle(element, 'left', '0');
        this.renderer.setStyle(element, 'z-index', zIndex);
        if (this.height && this.width) {
            this._setGeometry(element);
        }
        else {
            this.renderer.setStyle(element, 'height', 'auto');
            this.renderer.setStyle(element, 'width', '100%');
        }
    }
    /**
     * @private
     * @param {?} element
     * @return {?}
     */
    _setGeometry(element) {
        this.renderer.setAttribute(element, 'height', `${this.height}`);
        this.renderer.setAttribute(element, 'width', `${this.width}`);
    }
    /**
     * @private
     * @return {?}
     */
    _deleteAllPathsSubscriptions() {
        for (const subscriptions of this._pathsSubscription) {
            for (const subscription of subscriptions) {
                subscription.unsubscribe();
            }
        }
        this._pathsSubscription = [];
    }
    /**
     * @private
     * @param {?} pos
     * @return {?}
     */
    _deletePathSubscription(pos) {
        for (const subscription of this._pathsSubscription[pos]) {
            subscription.unsubscribe();
        }
        this._pathsSubscription.splice(pos, 1);
    }
    /**
     * @private
     * @return {?}
     */
    _removeAllListeners() {
        this._removeAllMouseListeners();
        this._ImageLoadListener();
        this._ImageErrorListener();
    }
    /**
     * @private
     * @return {?}
     */
    _removeAllMouseListeners() {
        this._MousedownListener();
        this._MouseupListener();
        this._MouseLeaveListener();
        this._MousemoveListener();
        this._ContextmenuListener();
    }
    /**
     * @private
     * @return {?}
     */
    _MousedownListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _MouseupListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _MouseLeaveListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _MousemoveListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _ContextmenuListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _ImageLoadListener() {
    }
    /**
     * @private
     * @return {?}
     */
    _ImageErrorListener() {
    }
}
NgxCanvasAreaDrawDirective.DEFAULT_STROKE_COLOR = 'rgba(255, 255, 255, 0.7)';
NgxCanvasAreaDrawDirective.DEFAULT_FILL_COLOR = 'rgba(255, 255, 255, 0.2)';
NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_STROKE_COLOR = 'rgba(255, 255, 255, 1)';
NgxCanvasAreaDrawDirective.DEFAULT_HANDLER_FILL_COLOR = 'rgba(255, 255, 255, 1)';
NgxCanvasAreaDrawDirective.decorators = [
    { type: Directive, args: [{
                selector: '[canvasAreaDraw]',
                exportAs: 'canvasAreaDraw'
            },] }
];
/** @nocollapse */
NgxCanvasAreaDrawDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: NgZone }
];
NgxCanvasAreaDrawDirective.propDecorators = {
    defaultPaths: [{ type: Input }],
    defaultActivePathIndex: [{ type: Input }],
    notifyWhileMoving: [{ type: Input }],
    allowDelete: [{ type: Input }],
    activePathChange: [{ type: Output }],
    pathAdded: [{ type: Output }],
    pathDeleted: [{ type: Output }],
    imageUrl: [{ type: Input, args: ['canvasAreaDraw',] }],
    strokeColor: [{ type: Input, args: ['strokeColor',] }],
    fillColor: [{ type: Input, args: ['fillColor',] }],
    handlerStrokeColor: [{ type: Input, args: ['handlerStrokeColor',] }],
    handlerFillColor: [{ type: Input, args: ['handlerFillColor',] }],
    scaleContent: [{ type: HostListener, args: ['window:resize',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxCanvasAreaDrawModule {
}
NgxCanvasAreaDrawModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NgxCanvasAreaDrawDirective
                ],
                exports: [
                    NgxCanvasAreaDrawDirective
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { getShape, BaseShape, BasePath, GenericPath, Rect, Pencil, NgxCanvasAreaDrawDirective, NgxCanvasAreaDrawModule };

//# sourceMappingURL=ngx-canvas-area-draw.js.map