import { AfterViewInit, ElementRef, EventEmitter, NgZone, OnDestroy, Renderer2 } from '@angular/core';
import { BasePath } from './shapes';
import { PathData } from './models';
export declare class NgxCanvasAreaDrawDirective implements AfterViewInit, OnDestroy {
    private element;
    private renderer;
    private ngZone;
    static DEFAULT_STROKE_COLOR: string;
    static DEFAULT_FILL_COLOR: string;
    static DEFAULT_HANDLER_STROKE_COLOR: string;
    static DEFAULT_HANDLER_FILL_COLOR: string;
    defaultPaths: PathData[];
    defaultActivePathIndex: number;
    notifyWhileMoving: boolean;
    allowDelete: boolean;
    activePathChange: EventEmitter<number>;
    pathAdded: EventEmitter<void>;
    pathDeleted: EventEmitter<number>;
    paths: BasePath[];
    height: number;
    width: number;
    isLoading: boolean;
    isDrawing: boolean;
    private _pencil;
    private _activePathPosition;
    private _baseCanvas;
    private _baseImage;
    private _pencilSubscription;
    private _pathsSubscription;
    constructor(element: ElementRef, renderer: Renderer2, ngZone: NgZone);
    private _imageUrl;
    imageUrl: string;
    private _strokeColor;
    strokeColor: string;
    private _fillColor;
    fillColor: string;
    private _handlerStrokeColor;
    handlerStrokeColor: string;
    private _handlerFillColor;
    handlerFillColor: string;
    ngAfterViewInit(): void;
    getPathImage(path: BasePath): string;
    getImageInPosition(position?: number): string;
    startDrawing(): void;
    addPath(pathData: PathData, notifyChange?: boolean): void;
    ngOnDestroy(): void;
    private _updateGeometry;
    private scaleContent;
    private _setUpPencil;
    private _setActivePathPosition;
    private applyHandlerStrokeColor;
    private _applyHandlerFillColor;
    private _applyFillColor;
    private _applyStrokeColor;
    private _removeBaseImage;
    private _removeAllPaths;
    private _removeBaseCanvas;
    private _createNewBaseCanvas;
    private _removePencil;
    private _resetIndicators;
    private _createBaseImage;
    private _listenImageImageError;
    private _listenImageLoad;
    private _createNewPencil;
    private _addDefaultPaths;
    private _paint;
    private _finishDrawing;
    private _checkPathClicked;
    private _onMouseleave;
    private _onMousedown;
    private _onMouseup;
    private _deletePath;
    private _onContextmenu;
    private _onMovePath;
    private _onMovePoint;
    private _onResizePath;
    private _getMousePos;
    private _setStyle;
    private _setGeometry;
    private _deleteAllPathsSubscriptions;
    private _deletePathSubscription;
    private _removeAllListeners;
    private _removeAllMouseListeners;
    private _MousedownListener;
    private _MouseupListener;
    private _MouseLeaveListener;
    private _MousemoveListener;
    private _ContextmenuListener;
    private _ImageLoadListener;
    private _ImageErrorListener;
}
