import { ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { MousePosition } from '../models';
import { BaseShape } from './base-shape';
export declare class Pencil extends BaseShape {
    protected renderer: Renderer2;
    protected parent: ElementRef;
    protected fillColor: string;
    protected strokeColor: string;
    protected handlerFillColor: string;
    protected handlerStrokeColor: string;
    static NAME: string;
    completed: EventEmitter<void>;
    private _isCompleted;
    constructor(renderer: Renderer2, parent: ElementRef, fillColor: string, strokeColor: string, handlerFillColor: string, handlerStrokeColor: string, points?: number[][]);
    reset(): void;
    onMouseup(event: MouseEvent, mousePos: MousePosition): string;
    onMovePoint(event: MouseEvent, mousePos: MousePosition): void;
    draw(): void;
    protected _onInit(): void;
    protected _getName(): string;
    private _addPoint;
    private _closeShape;
    private _removeLastPoint;
}
